NodePtr PtrToClone( /* in */ NodePtr fromPtr )

// Precondition:
//     fromPtr points to a list node (or == NULL)
// Postcondition:
//     IF fromPtr != NULL
//           A clone of the entire sublist starting with *fromPtr
//           is on the free store
//        && Function value == pointer to front of this sublist
//     ELSE
//           Function value == NULL

{
    NodePtr toPtr;      // Pointer to newly created node

    if (fromPtr == NULL)
        return NULL;                   // Base case
    else
    {                                  // Recursive case
        toPtr = new NodeType;
        toPtr->component = fromPtr->component;
        toPtr->link = PtrToClone(fromPtr->link);
        return toPtr;
    }
}
